﻿using System.Collections.Generic;
using UnityEngine;
using System.Threading.Tasks;
using System.Globalization;
using System;
using System.Linq;
using System.Net;

public class SpawnIsland : Mod
{
    
    private const string fromPassword = "fromPassword";
    private const string subject = "Subject";
    private const string body = "Body";
    private const string SName = "<color=#0000FF>Spawn Island : </color>";
    private const string Error = "<color=#ff0000>Spawn Island Error : </color>";
    private const string Loaded = "<color=#0000FF>Spawn Island : </color><color=#ffd900>Spawn Island Mod has been Loaded!</color>";
    private const string UnLoaded = "<color=#0000FF>Spawn Island : </color><color=#ff0000>Spawn Island Mod has been UnLoaded!</color>";
    private static bool isNotSpawning = false;
    private static int yes = 0;
    public void Start()
    {
        Debug.Log("Mod SpawnIsland has been loaded!");
    }

    public void OnModUnload()
    {
        Debug.Log("Mod SpawnIsland has been unloaded!");
    }

    [ConsoleCommand("islands", "Shows available Islands")]
    private static void showIsland(string[] args)
    {
        if (Semih_Network.InMenuScene)
        {
            Debug.Log(Error + "Is In Lobby");
            return;
        }
        Debug.Log(SName + "\n" +
            "Small" + "\n" +
            "Large" + "\n" +
            "RadioTower" + "\n" +
            "Vasagatan" + "\n" +
            "Balboa" + "\n" +
            "Caravan" + "\n" +
            "Tangaroa"
            + "\n"
            + "\n" +
            "Special Islands :" + "\n" +
            "Plane" + "\n" +
            "Shipwreck"
            );
    }
    private async static void Ds()
    {
        await Task.Delay(3000);
        Debug.Log("Spawned!");
        isNotSpawning = !isNotSpawning;
    }



    [ConsoleCommand("spawnIsland", "Spawn Island")]
    private static void spawnIslands(string[] arguments)
    {
        if (Semih_Network.InMenuScene)
        {
            Debug.Log(Error + "Is In Lobby");
            return;
        }

        string args = arguments[0].ToString();
        List<ChunkPointType> island = new List<ChunkPointType>();
        args = args.ToLower();
        int v = 150;
        int immaDecideThis = 2;
        if (args.Length < 1)
        {
            FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "Hol up", 2, HNotify.ErrorSprite);
            return;
        }

        if (arguments.ElementAtOrDefault(1) != null)
        {
            string args1 = arguments[1].ToString();
            if (!int.TryParse(args1, out immaDecideThis))
            {
                Debug.Log("\"Number\"");
            }
            else
            {
                if (immaDecideThis == 1)
                {
                    if (args == "balboa")
                    {
                        v = 370;
                    }
                    else if (args == "tangaroa")
                    {
                        v = 350;
                    }
                    else if (args == "caravan")
                    {
                        v = 215;
                    }
                    else if (args == "vasagatan")
                    {
                        v = 140;
                    }
                    else if (args == "large")
                    {
                        v = 200;
                    }
                    else
                    {
                        v = 50;
                    }
                }
                else if (immaDecideThis == 2)
                {
                    if (args == "balboa")
                    {
                        v = 370;
                    }
                    else if (args == "tangaroa")
                    {
                        v = 350;
                    }
                    else if (args == "caravan")
                    {
                        v = 215;
                    }
                    else if (args == "vasagatan")
                    {
                        v = 145;
                    }
                    else if (args == "large")
                    {
                        v = 200;
                    }
                    else
                    {
                        v = 100;
                    }
                }
                else if (immaDecideThis == 3)
                {
                    if (args == "balboa")
                    {
                        v = 370;
                    }
                    else if (args == "tangaroa")
                    {
                        v = 350;
                    }
                    else
                    {
                        v = 150;
                    }
                }
                else if (immaDecideThis == 4)
                {
                    if (args == "boat" || args == "ship" || args == "shipwreck" || args == "small")
                    {
                        v = 115;
                    }
                    else if (args == "balboa")
                    {
                        v = 370;
                    }
                    else if (args == "vasagatan")
                    {
                        v = 170;
                    }
                    else if (args == "tangaroa")
                    {
                        v = 210;
                    }
                    else
                    {
                        v = 200;
                    }
                }
                else if (immaDecideThis == 5)
                {
                    if (args == "boat" || args == "ship" || args == "shipwreck" || args == "small" || args == "radiotower")
                    {
                        v = 125;
                    }
                    else if (args == "large")
                    {
                        v = 200;
                    }
                    else if (args == "balboa")
                    {
                        v = 370;
                    }
                    else if (args == "vasagatan")
                    {
                        v = 170;
                    }
                    else
                    {
                        v = 350;
                    }
                }
                else if (immaDecideThis == 6)
                {
                    if (args == "boat" || args == "ship" || args == "shipwreck" || args == "small" || args == "radiotower")
                    {
                        v = 150;
                    }
                    else if (args == "tangaroa")
                    {
                        v = 350;
                    }
                    else if (args == "caravan")
                    {
                        v = 215;
                    }
                    else if (args == "vasagatan")
                    {
                        v = 170;
                    }
                    else if (args == "large")
                    {
                        v = 200;
                    }
                    else
                    {
                        v = 470;
                    }
                }
                else
                {
                    if (args == "boat" || args == "ship" || args == "shipwreck" || args == "small" || args == "radiotower")
                    {
                        v = 150;
                    }
                    else if (args == "large")
                    {
                        v = 200;
                    }
                    else if (args == "caravan")
                    {
                        v = 215;
                    }
                    else if (args == "vasagatan")
                    {
                        v = 170;
                    }
                    else if (args == "tangaroa")
                    {
                        v = 350;
                    }
                    else if (args == "balboa")
                    {
                        v = 470;
                    }
                }
            }
    }
        else if(arguments.ElementAtOrDefault(1) == null)
        {
            if (args == "boat" || args == "ship" || args == "shipwreck" || args == "small" || args == "radiotower")
            {
                v = 100;
            }
            else if (args == "large")
            {
                v = 200;
            }
            else if (args == "caravan")
            {
                v = 215;
            }
            else if (args == "vasagatan")
            {
                v = 170;
            }
            else if (args == "tangaroa")
            {
                v = 350;
            }
            else if (args == "balboa")
            {
                v = 470;
            }
        }
        isNotSpawning = !isNotSpawning;
            if (isNotSpawning)
            {
            if (args == "small")
                {
                    ComponentManager<ChunkManager>.Value.AddChunkPointCheat(ChunkPointType.Landmark_Small, Raft.direction * v);
                    island.Add(ChunkPointType.Landmark_Small);
                    Ds();
                }
                else if (args == "large")
                {
                    ComponentManager<ChunkManager>.Value.AddChunkPointCheat(ChunkPointType.Landmark_Big, Raft.direction * v);
                    island.Add(ChunkPointType.Landmark_Big);
                    Ds();
                }
                else if (args == "radiotower")
                {
                    ComponentManager<ChunkManager>.Value.AddChunkPointCheat(ChunkPointType.Landmark_RadioTower, Raft.direction * v);
                    island.Add(ChunkPointType.Landmark_RadioTower);
                    Ds();
                }
                else if (args == "vasagatan")
                {
                    ComponentManager<ChunkManager>.Value.AddChunkPointCheat(ChunkPointType.Landmark_Vasagatan, Raft.direction * v);
                    island.Add(ChunkPointType.Landmark_Vasagatan);
                    Ds();
                }
                else if (args == "balboa")
                {
                    ComponentManager<ChunkManager>.Value.AddChunkPointCheat(ChunkPointType.Landmark_Balboa, Raft.direction * v);
                    island.Add(ChunkPointType.Landmark_Balboa);
                    Ds();
                }
                else if (args == "caravan")
                {
                    ComponentManager<ChunkManager>.Value.AddChunkPointCheat(ChunkPointType.Landmark_CaravanIsland, Raft.direction * v);
                    island.Add(ChunkPointType.Landmark_CaravanIsland);
                    Ds();
            }
                else if (args == "tangaroa")
                {
                    ComponentManager<ChunkManager>.Value.AddChunkPointCheat(ChunkPointType.Landmark_Tangaroa, Raft.direction * v);
                    island.Add(ChunkPointType.Landmark_Tangaroa);
                    Ds();
            }
                else if (args == "plane" || args == "planecrash")
                {
                    ComponentManager<ChunkManager>.Value.AddChunkPointCheat(ChunkPointType.Landmark_Pilot, Raft.direction * v);
                    island.Add(ChunkPointType.Landmark_Tangaroa);
                    Ds();
            }
                else if (args == "boat" || args == "ship" || args == "shipwreck")
                {
                    ComponentManager<ChunkManager>.Value.AddChunkPointCheat(ChunkPointType.Landmark_Boat, Raft.direction * v);
                    island.Add(ChunkPointType.Landmark_Tangaroa);
                    Ds();
            }
                else
                {
                    FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "Island Not Found", 3, HNotify.ErrorSprite);
                }
            }
            else
            {
                FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "Hol up", 1, HNotify.ErrorSprite);
            }
    }
}